/*
 * Copyright (c) 2010-2011, The MiCode Open Source Community (www.micode.net)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *        http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

/*
 * Description：用于支持小米便签最底层的数据库相关操作，和sqlnote的关系上是子集关系，即data是note的子集（节点）。
 * SqlData其实就是也就是所谓数据中的数据
 */

package net.micode.notes.gtask.data;
/*
 * 功能描述：
 * 实现过程：
 * 参数注解：
 */

import android.content.ContentResolver;
import android.content.ContentUris;
import android.content.ContentValues;
import android.content.Context;
import android.database.Cursor;
import android.net.Uri;
import android.util.Log;

import net.micode.notes.data.Notes;
import net.micode.notes.data.Notes.DataColumns;
import net.micode.notes.data.Notes.DataConstants;
import net.micode.notes.data.Notes.NoteColumns;
import net.micode.notes.data.NotesDatabaseHelper.TABLE;
import net.micode.notes.gtask.exception.ActionFailureException;

import org.json.JSONException;
import org.json.JSONObject;


public class SqlData {
    /*
     * 功能描述：得到类的简写名称存入字符串TAG中
     * 实现过程：调用getSimpleName ()函数
     */
    private static final String TAG = SqlData.class.getSimpleName();// 定义一个私有的静态常量 TAG，用于在日志输出中作为标签

    private static final int INVALID_ID = -99999;//为mDataId置初始值-99999

    /*
     * 来自Notes类中定义的DataColumn中的一些常量
     */

    // 集合了interface DataColumns中所有SF常量
    public static final String[] PROJECTION_DATA = new String[] {
            DataColumns.ID, DataColumns.MIME_TYPE, DataColumns.CONTENT, DataColumns.DATA1,
            DataColumns.DATA3
    };
    /*
     * 以下五个变量作为sql表中5列的编号
     */
    public static final int DATA_ID_COLUMN = 0;// 数据记录ID所在列的索引，通常为第 0 列

    public static final int DATA_MIME_TYPE_COLUMN = 1;// 数据的MIME类型所在列的索引，通常为第 1 列

    public static final int DATA_CONTENT_COLUMN = 2;// 数据内容所在列的索引，通常为第 2 列

    public static final int DATA_CONTENT_DATA_1_COLUMN = 3;// 数据中的DATA1字段所在列的索引，通常为第 3 列

    public static final int DATA_CONTENT_DATA_3_COLUMN = 4;// 数据中的DATA3字段所在列的索引，通常为第 4 列

    private ContentResolver mContentResolver;
    //判断是否直接用Content生成，是为true，否则为false
    private boolean mIsCreate;// 表示数据记录是否是新创建的标识

    private long mDataId;// 数据记录的ID

    private String mDataMimeType;// 数据记录的MIME类型

    private String mDataContent;// 数据记录的内容

    private long mDataContentData1;// 数据记录中的DATA1字段

    private String mDataContentData3;// 数据记录中的DATA3字段

    private ContentValues mDiffDataValues;// 保存数据记录的差异值

    /*
     * 功能描述：构造函数，用于初始化数据
     * 参数注解：mContentResolver用于获取ContentProvider提供的数据
     * 参数注解： mIsCreate表征当前数据是用哪种方式创建（两种构造函数的参数不同）
     * 参数注解：
     */
    public SqlData(Context context) {
        mContentResolver = context.getContentResolver();
        mIsCreate = true;
        mDataId = INVALID_ID;//mDataId置初始值-99999
        mDataMimeType = DataConstants.NOTE;
        mDataContent = "";
        mDataContentData1 = 0;
        mDataContentData3 = "";
        mDiffDataValues = new ContentValues();
    }


    /*
     * 功能描述：构造函数，初始化数据
     * 参数注解：mContentResolver用于获取ContentProvider提供的数据
     * 参数注解： mIsCreate表征当前数据是用哪种方式创建（两种构造函数的参数不同）
     * 参数注解：
     */
    public SqlData(Context context, Cursor c) {
        mContentResolver = context.getContentResolver();// 获取 ContentResolver 对象
        mIsCreate = false;// 将数据记录的新建标识设置为 false
        loadFromCursor(c);// 从 Cursor 对象中加载数据记录
        mDiffDataValues = new ContentValues();// 创建 ContentValues 对象，用于保存数据记录的差异值
    }

    /*
     * 功能描述：从光标处加载数据
     * 从当前的光标处将五列的数据加载到该类的对象
     */
    private void loadFromCursor(Cursor c) {
        // 获取游标中对应字段位置的字段值，并保存到成员变量中
        mDataId = c.getLong(DATA_ID_COLUMN);//获取数据记录的ID值，并保存到成员变量 mDataId 中
        mDataMimeType = c.getString(DATA_MIME_TYPE_COLUMN);//获取数据记录的MIME类型，并保存到成员变量 mDataMimeType 中。
        mDataContent = c.getString(DATA_CONTENT_COLUMN);//获取数据记录的内容，并保存到成员变量 mDataContent 中。
        mDataContentData1 = c.getLong(DATA_CONTENT_DATA_1_COLUMN);//获取数据记录中的DATA1字段值，并保存到成员变量 mDataContentData1 中。
        mDataContentData3 = c.getString(DATA_CONTENT_DATA_3_COLUMN);//获取数据记录中的DATA3字段值，并保存到成员变量 mDataContentData3 中。
    }


    /*
     * 功能描述：设置用于共享的数据，并提供异常抛出与处理机制
     * 参数注解：
     */
    public void setContent(JSONObject js) throws JSONException {
        long dataId = js.has(DataColumns.ID) ? js.getLong(DataColumns.ID) : INVALID_ID; // 从JSONObject中获取DataColumns.ID字段的值，如果不存在则设置为INVALID_ID
        if (mIsCreate || mDataId != dataId) { // 如果是新创建的数据或者mDataId与dataId不相等
            mDiffDataValues.put(DataColumns.ID, dataId); // 将dataId添加到差异数据中
        }
        mDataId = dataId; // 更新mDataId的值

        String dataMimeType = js.has(DataColumns.MIME_TYPE) ? js.getString(DataColumns.MIME_TYPE)
                : DataConstants.NOTE; // 从JSONObject中获取DataColumns.MIME_TYPE字段的值，如果不存在则设置为DataConstants.NOTE
        if (mIsCreate || !mDataMimeType.equals(dataMimeType)) { // 如果是新创建的数据或者mDataMimeType与dataMimeType不相等
            mDiffDataValues.put(DataColumns.MIME_TYPE, dataMimeType); // 将dataMimeType添加到差异数据中
        }
        mDataMimeType = dataMimeType; // 更新mDataMimeType的值

        String dataContent = js.has(DataColumns.CONTENT) ? js.getString(DataColumns.CONTENT) : ""; // 从JSONObject中获取DataColumns.CONTENT字段的值，如果不存在则设置为空字符串
        if (mIsCreate || !mDataContent.equals(dataContent)) { // 如果是新创建的数据或者mDataContent与dataContent不相等
            mDiffDataValues.put(DataColumns.CONTENT, dataContent); // 将dataContent添加到差异数据中
        }
        mDataContent = dataContent; // 更新mDataContent的值

        long dataContentData1 = js.has(DataColumns.DATA1) ? js.getLong(DataColumns.DATA1) : 0; // 从JSONObject中获取DataColumns.DATA1字段的值，如果不存在则设置为0
        if (mIsCreate || mDataContentData1 != dataContentData1) { // 如果是新创建的数据或者mDataContentData1与dataContentData1不相等
            mDiffDataValues.put(DataColumns.DATA1, dataContentData1); // 将dataContentData1添加到差异数据中
        }
        mDataContentData1 = dataContentData1; // 更新mDataContentData1的值

        String dataContentData3 = js.has(DataColumns.DATA3) ? js.getString(DataColumns.DATA3) : ""; // 从JSONObject中获取DataColumns.DATA3字段的值，如果不存在则设置为空字符串
        if (mIsCreate || !mDataContentData3.equals(dataContentData3)) { // 如果是新创建的数据或者mDataContentData3与dataContentData3不相等
            mDiffDataValues.put(DataColumns.DATA3, dataContentData3); // 将dataContentData3添加到差异数据中
        }
        mDataContentData3 = dataContentData3; // 更新mDataContentData3的值
    }

    /*
     * 功能描述：获取共享的数据内容，并提供异常抛出与处理机制
     * 参数注解：
     */
    public JSONObject getContent() throws JSONException {
        if (mIsCreate) {
            // 如果数据还未在数据库中创建，则打印错误日志并返回null
            Log.e(TAG, "it seems that we haven't created this in database yet");
            return null;
        }
        //创建JSONObject对象。并将相关数据放入其中，并返回。
        JSONObject js = new JSONObject();
        js.put(DataColumns.ID, mDataId); // 将mDataId字段的值放入JSONObject中
        js.put(DataColumns.MIME_TYPE, mDataMimeType); // 将mDataMimeType字段的值放入JSONObject中
        js.put(DataColumns.CONTENT, mDataContent); // 将mDataContent字段的值放入JSONObject中
        js.put(DataColumns.DATA1, mDataContentData1); // 将mDataContentData1字段的值放入JSONObject中
        js.put(DataColumns.DATA3, mDataContentData3); // 将mDataContentData3字段的值放入JSONObject中
        return js; // 返回JSONObject对象
    }

    /*
     * 功能描述：commit函数用于把当前造作所做的修改保存到数据库
     * 参数注解：
     */
    public void commit(long noteId, boolean validateVersion, long version) {

        if (mIsCreate) {
            // 如果数据还未在数据库中创建，则执行插入操作
            if (mDataId == INVALID_ID && mDiffDataValues.containsKey(DataColumns.ID)) {
                // 如果mDataId为无效值，并且mDiffDataValues中包含DataColumns.ID字段，则移除该字段
                mDiffDataValues.remove(DataColumns.ID);
            }

            // 设置DataColumns.NOTE_ID字段的值为noteId
            mDiffDataValues.put(DataColumns.NOTE_ID, noteId);
            // 在Notes.CONTENT_DATA_URI中插入mDiffDataValues并返回Uri对象
            Uri uri = mContentResolver.insert(Notes.CONTENT_DATA_URI, mDiffDataValues);
            try {
                // 将Uri路径中的第二个片段转换为long类型，并赋值给mDataId
                mDataId = Long.valueOf(uri.getPathSegments().get(1));
            } catch (NumberFormatException e) {
                // 如果获取ID出错则输出错误日志并抛出ActionFailureException异常
                Log.e(TAG, "Get note id error :" + e.toString());
                throw new ActionFailureException("create note failed");
            }
        } else {
            if (mDiffDataValues.size() > 0) {
                int result = 0;
                if (!validateVersion) {
                    // 如果不需要验证版本，则直接通过mDataId更新mDiffDataValues到数据库中
                    result = mContentResolver.update(ContentUris.withAppendedId(
                            Notes.CONTENT_DATA_URI, mDataId), mDiffDataValues, null, null);
                } else {
                    // 如果需要验证版本，则通过noteId和version进行更新
                    result = mContentResolver.update(ContentUris.withAppendedId(
                                    Notes.CONTENT_DATA_URI, mDataId), mDiffDataValues,
                            " ? in (SELECT " + NoteColumns.ID + " FROM " + TABLE.NOTE
                                    + " WHERE " + NoteColumns.VERSION + "=?)", new String[] {
                                    String.valueOf(noteId), String.valueOf(version)
                            });
                }
                if (result == 0) {
                    // 如果没有更新任何数据，则输出警告日志
                    Log.w(TAG, "there is no update. maybe user updates note when syncing");
                }
            }
        }

        // 清空差异数据
        mDiffDataValues.clear();
        // 将新建标记设为false
        mIsCreate = false;
    }
    /**
     * 获取数据ID的方法
     * @return 数据ID
     */
    public long getId() {
        return mDataId;
    }

}
